<!DOCTYPE html>
<html>
	<head>
		<meta http-equiv="X-UA-Compatible" content="IE=edge">
		<meta http-equiv="content-type" content="text/html; charset=utf-8" />

		<title>MQTT Container</title>

		<link rel="stylesheet" type="text/css" href="css/base.css" />
		<link rel="stylesheet" type="text/css" href="css/framing.css" />
		<link rel="stylesheet" type="text/css" href="css/home.css" />
		<link rel="stylesheet" type="text/css" href="css/style.css" />
		<link rel="stylesheet" type="text/css" href="css/switches.css" />
		<link rel="stylesheet" type="text/css" href="css/help-tip.css" />
		<link rel="stylesheet" type="text/css" href="css/keyframes.css" />
		<script type="text/javaScript" src="js/jquery-3.6.0.min.js"></script>
		<script type="text/javaScript" src="js/cert_decoder.js"></script>
		<script type="text/javaScript" src="js/security.js"></script>
		<script type="text/javaScript">
			function init()
			{
				init_security(false);
				get_configuration();
				fetch_broker_clients();
				window.setInterval(function(){
					fetch_broker_log();
					fetch_broker_clients();
				}, 2500);
			}

			function get_configuration() {
				$.get( "/node/config", function( data ) {
					$( '#application_name' ).val(data.application_name);
					$( '#element_name' ).val(data.element_name);
					const title = data.application_name + "/" + data.element_name;
					const headline = "MQTT " + title;
					$(document).attr('title', title);
					document.getElementById("headline").innerText = headline;
				}, "json");
			}

			function configure()
			{
				var http = new XMLHttpRequest();
				const name = document.getElementById("application_name").value;
				const elemnt = document.getElementById("element_name").value;
				var configuring_name = true;

				patch(
					"/node/config",
					JSON.stringify({"application_name":name,"element_name":elemnt}),
					"application/json"
				)
				const title = name + "/" + elemnt;
				$(document).attr('title', title);
				const headline = "MQTT " + title;
				document.getElementById("headline").innerText = headline;
			}
			let user_conf_fetched = false;
			function fetch_misc_config_once()
			{
				if (user_conf_fetched == false) {
					fetch_misc_config();
				}
			}
			function fetch_misc_config()
			{
				var http = new XMLHttpRequest();

				const misc_config_obj = document.getElementById("misc-config");
				var configuring_name = true;
				var configuring_tls = true

				http.open("GET", "/mqttbroker/mosquitto/advanced-config");
				http.send();
				http.addEventListener('load', function() {
					user_conf_fetched = true;
					const response = http.responseText;
					try {
						misc_config_obj.value = response;
					} catch (error) {
					}
				});
			}

			function push_misc_config()
			{
				var http = new XMLHttpRequest();

				const misc_config_obj = document.getElementById("misc-config");
				var configuring_name = true;
				var configuring_tls = true

				http.open("PATCH", "/mqttbroker/mosquitto/advanced-config");
				http.setRequestHeader("Content-Type", "text/plain;charset=UTF-8");
				const response = misc_config_obj.value;
				http.send(response);
				http.addEventListener('load', function() {
					//notify updated
					alert("Configuration successfully sent!");
				});
			}
			function restart_broker() {
				var http = new XMLHttpRequest();

				http.open("PATCH", "/mqttbroker/restart");
				http.addEventListener('load', function() {
					alert("Restart sent!");
				});
				http.send();
			}
			function fetch_broker_log()
			{
				var http = new XMLHttpRequest();

				const misc_config_obj = document.getElementById("broker-log");
				var configuring_name = true;
				var configuring_tls = true

				http.open("GET", "/mqttbroker/log");
				http.send();
				http.addEventListener('load', function() {
					const response = http.responseText;
					try {
						misc_config_obj.value = response;
					} catch (error) {
					}
					// prevent auto-scrolling to the bottom with each incoming log
					// misc_config_obj.scrollTop = misc_config_obj.scrollHeight;
				});
			}
			function fetch_broker_clients()
			{
				var http = new XMLHttpRequest();

				const client_list_obj = document.getElementById("client_list");

				http.open("GET", "/mqttbroker/clients");
				http.send();
				http.addEventListener('load', function() {
					const response = http.responseText;
					try {
						var obj = JSON.parse(response);
						var clients = [];
						obj.forEach(element => {
							// use hostname and client id if present,
							// otherwise ip address and client id
							if(element.hostname.length > 0) {
								clients.push(element.hostname + " (" + element.id + ")");
							} else {
								var tmp = element.ip + " (" + element.id + ")";
								clients.push(tmp);
							}
						});
						// sort host names descending
						clients.sort();
						clients.reverse();

						// add linebrakes and revert sort order
						var represents = "";
						clients.forEach(element => {
							represents = element + "\n" + represents;
						});
						client_list_obj.value = represents;
					} catch (error) {
						console.log(error);
					}
					client_list_obj.scrollTop = client_list_obj.scrollHeight;
				});
			}
		</script>
	</head>

	<body onload=init()>
		<div class="headercontainer">
			<!--Metanav-->
			<div class="meta">
				<div class="left" style="line-height: 24px;font-weight: bold;" id="headline">MQTT</div>
				<div class="middle"></div>
				<div class="right"><span></span></div>
			</div>
			<!--END Metanav-->

			<div class="header" id="header_cnt">
				<div class="headerlogo"><img src="images/logo_perinet.png" width="258" height="94" alt="" /></div>
			</div>
		</div>

		<!--Content-->
		<div id="content">
			<div id="inner_content">
				<div class="inputitem">
					<section>
						<h2>MQTT broker description</h2>
						The <span style="font-weight:bold;">MQTT broker</span> container provides a lightweight broker for secure and efficient 
						IoT communication via publish/subscribe messaging. For further information refer to
						<a target="_blank" href="https://docs.perinet.io/">Perinet documentation</a> or
						to the <a target="_blank" href="api.html">MQTT broker API documentation</a>.
					</section>
				</div>
				<div class="contentline_single gap10_20" style="margin-top:50px"></div>
				<div class="inputitem">
					<section>
						<h2>Connected MQTT Clients</h2>
						<table style="padding-left: 50px">
							<tr>
								<td class="left"></td>
								<td class="textarea" style="padding-left:35px;" align="left">
									<textarea type="text" readonly id="client_list" style="width:550px; line-height:1; padding:10px; border:none; max-height:350px;"></textarea>
								</td>
							</tr>
						</table>
					</section>
				</div>
				<div class="contentline_single gap10_20" style="margin-top:50px"></div>
				<div class="inputitem">
					<section>
						<h2>Node Configuration</h2>
						<table style="padding-left: 50px">
							<tr>
								<td class="left">Application name:</td>
								<td class="input">
									<input style="margin-left:25px; width:310px" type="text" id="application_name" placeholder="application_name"></input></td>
								</td>
							</tr>
							<tr>
								<td class="left">Element name:</td>
								<td class="input">
									<input style="margin-left:25px; width:310px" type="text" id="element_name" placeholder="element_name"></input></td>
								</td>
							</tr>
							<tr>
								<td class="left"></td>
								<td class="input">
									<input type="submit" style="margin-left:75px;width:260px" value="Push configuration" onclick="configure()"></input>
								</td>
							</tr>
						</table>
					</section>
				</div>
				<div class="contentline_single gap10_20"></div>
				<div class="inputitem">
					<section>
						<details ontoggle="fetch_misc_config_once()">
							<summary style="
								font-size: 1.4rem;
								font-weight: bold;
								margin-block-start: 0.83em;
								margin-block-end: 0.83em;
								margin-inline-start: 0px;
								margin-inline-end: 0px;
							">
							Advanced MQTT broker configuration
							</summary>
							<table style="padding-left: 50px">
								<tr>
									<td class="left">Restart MQTTBroker:</td>
									<td class="textarea" style="padding-left:35px;" align="left">
										<input style="!important;text-decoration:none; margin-left:130px;" value="Restart MQTTBroker" id="download_misc_config" type="submit" onclick="restart_broker()"></input>
									</td>
								</tr>
								<tr>
									<td class="left">Mosquitto Log:</td>
									<td class="textarea" style="padding-left:35px;" align="left">
										<textarea type="text" readonly id="broker-log" style="width:550px; border:none; line-height:1; padding:10px; height:350px;"></textarea>
									</td>
								</tr>
								<tr>
									<td class="left">Custom Mosquitto Config:</td>
									<td class="textarea" style="padding-left:35px;" align="left">
										<textarea type="text" id="misc-config" style="width:550px; line-height:1; padding:10px; height:350px;"></textarea>
										<input style="!important;text-decoration:none; margin-left:130px;" value="Fetch advanced broker configuration" id="download_misc_config" type="submit" onclick="fetch_misc_config()"></input>
										<input style="!important;text-decoration:none; margin-left:130px;" value="Push advanced broker configuration" id="upload_misc_config" type="submit" onclick="push_misc_config()"></input>
									</td>
								</tr>
							</table>
						</details>
					</section>
				</div>				
				<div class="contentline_single gap10_20"></div>
				<div class="inputitem">
					<section>
						<h2>Security configuration</h2>
						<table id="security_table">
						</table>
					</section>
				</div>
				
				<div class="contentline_single gap10_20"><br/> </div><br/><br/><br/>

				<!--Footer-->
				<div class="footer">
					<div>
						<div style="float:left;width:140px;text-align:left;font-weight:bold;">periMICA</div>
						<div style="float:left;width:780px;text-align:right;"><span></span></div>
					</div>
				</div>
			</div>
		</div>
	</body>
</html>
